﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using PropertyGrid.ViewModel;
using PropertyGrid.ViewModel.PropertyInspector;

namespace PropertyGrid.PropertyDescriptor
{
    public class ParameterPropertyDescriptor: System.ComponentModel.PropertyDescriptor
    {
        /// <summary>
        /// The model
        /// </summary>
        public ParameterViewModel model { get; private set; }      
        
        /// <summary>
        /// Initializes a new instance of the <see cref="ParameterPropertyDescriptor"/> class.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <param name="attrs">The attrs.</param>
        /// <param name="model">The model.</param>
        public ParameterPropertyDescriptor(ParameterViewModel model) : base(model.Name, new Attribute[] {})
        {            
            this.model = model;         
        }        

        public override string DisplayName
        {
            get { return model.Name; }
        }

        public override string Category
        {
            get { return model.Category;  }
        }

        public override bool CanResetValue(object component)
        {
            return true;
        }

        public override object GetValue(object component)
        {
            return model.Value;
        }

        

        public override void ResetValue(object component)
        {

        }

        public override PropertyDescriptorCollection GetChildProperties(object instance, Attribute[] filter)
        {

           // var descriptor = new ParameterPropertyDescriptor(Properties, idx);
            return base.GetChildProperties(model, filter);
        }

        public override void SetValue(object component, object value)
        {            
            //this.OnValueChanged(component, EventArgs.Empty);    
        }

        public override bool ShouldSerializeValue(object component)
        {
            return true;
        }

        public override Type ComponentType { get { return model.GetType(); } }
        public override bool IsReadOnly { get { return false; } }
        public override Type PropertyType { get { return model.Value.GetType(); } }
    }
}
