﻿using System.Collections.Generic;
using System.ComponentModel;
using PropertyGrid.PropertyDescriptor;
using PropertyGrid.ViewModel.PropertyInspector;
using System.Collections.ObjectModel;

namespace PropertyGrid.ViewModel
{
    public class ListGenericViewModel: CustomTypeDescriptorViewModel
    {        
        private ObservableCollection<ParameterViewModel> properties = new ObservableCollection<ParameterViewModel>();

        public ObservableCollection<ParameterViewModel> Properties
        {
            get { return properties; }
            set
            {
                properties = value;
                OnPropertyChanged();
            }
        }

        public ListGenericViewModel(string prefix)
        {
            //Properties.Add(new ParameterViewModel(prefix) { Value = prefix, Name = "First Name", Category = "Personal Data"});
            //Properties.Add(new ParameterViewModel("García") { Value = "García", Name = "Last Name", Category = "Personal Data" });

            ParameterViewModel pvm = new ParameterViewModel(prefix) { Value = prefix, Name = "First Name", Category = "Personal Data" };
            Properties.Add(pvm);
            pvm.PropertyChanged += Pvm_PropertyChanged;

            pvm = new ParameterViewModel("García") { Value = "García", Name = "Last Name", Category = "Personal Data" };
            Properties.Add(pvm);
            pvm.PropertyChanged += Pvm_PropertyChanged;
        }

        private void Pvm_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            ParameterViewModel pvm = sender as ParameterViewModel;
            OnPropertyChanged(pvm.Name);
        }

        public override PropertyDescriptorCollection GetProperties()
        {
            var propertyDescriptionCollection = new PropertyDescriptorCollection(null);
            foreach (var property in Properties)
            {
                propertyDescriptionCollection.Add(new ParameterPropertyDescriptor(property));
            }

            return propertyDescriptionCollection;
        }

        public override object GetPropertyOwner(System.ComponentModel.PropertyDescriptor pd)
        {
            var owner = pd as ParameterPropertyDescriptor;
            return (owner != null) ? owner.model.Value : null;
        }
    }
}