﻿using System.ComponentModel;
using PropertyGrid.PropertyDescriptor;
using PropertyGrid.Source;

namespace PropertyGrid.ViewModel.PropertyInspector
{
    public class ParameterViewModel : CustomTypeDescriptorViewModel
    {
        private string name = "PropertyName";

        public string Name
        {
            get { return name; }
            set
            {
                this.name = value;
                OnPropertyChanged();
            }
        }

        private string category = "Category 1";

        public string Category
        {
            get { return category; }
            set
            {
                this.category = value;
                OnPropertyChanged();
            }
        }

        private string value = "default";

        public string Value
        {
            get { return value; }
            set
            {
                this.value = value;
                OnPropertyChanged();
            }
        }

        private string _valueDefaultMethod = "default-first-name-method";

        public void ResetValue()
        {
            this.Value = _valueDefaultMethod;
        }

        public bool ShouldSerializeValue()
        {
            return !this.Value.Equals(_valueDefaultMethod); ;
        }

        public ParameterViewModel(string defaultValue)
        {
            _valueDefaultMethod = defaultValue;
        }

        public override PropertyDescriptorCollection GetProperties()
        {
            return new PropertyDescriptorCollection(new System.ComponentModel.PropertyDescriptor[] { new ParameterPropertyDescriptor(this) });
        }
    }
}
